clear, clc, clf

% The Process Transfer function Hp(s)
num_p=[1];
den1=[1, 0];
den2=[1, 1];
den_p = conv(den1,den2);
Hp = tf(num_p, den_p);

% The Measurement Transfer function Hm(s)
num_m=[1];
den_m=[3, 1];
Hm = tf(num_m, den_m);

% The PI Controller Transfer function Hc(s)
%Kp = 0.6; Ti = 9; % Ziegler?Nichols
%Kp = 0.2; Ti = 7.5; % Skogestad
Kp = 0.33; Ti = 43.5; % MATLAB pidtune() function

num = Kp*[Ti, 1];
den = [Ti, 0];
Hc = tf(num,den);

% The Loop Transfer function
L = series(series(Hc, Hp), Hm);
% Tracking transfer function
T=feedback(L,1);
% Sensitivity transfer function
S=1-T;

% Bode Diagram
figure(1)
bode(L), grid on

figure(2)
margin(L), grid on

[gm, pm, w180, wc] = margin(L);

wc
w180
gm
gmdB = 20*log10(gm)
pm

% Simulating step response for control system (tracking transfer function)
figure(3)
step(T)

% Poles
pole(T)
figure(4)
pzmap(T)

% Bandwidth
figure(5)
bodemag(L,T,S), grid on
